#pragma once

#include "GameObject.h"

enum GegenstandTyp
{
    KEIN_GEGENSTAND,
    PFEIL,
    LEBEN,
    SCHILD,
    SCHUH,
    GEIST,
    KUGEL,
    ROLLE,
    STURM,
    DRACHENAUGE,
    FEUERBALL,
    ENTERHAKEN,
    MINE,
    RWEISHEIT,
    RSTRENGTH,
    RBOSHEIT,
    RLEBEN,
    RTEMPO,
    ITEMANZAHL
};

bool consumable( GegenstandTyp typ );

float abklingzeit( GegenstandTyp typ );

bool storable( GegenstandTyp typ );

bool brauchtRichtung( GegenstandTyp typ );

class GegenstandTypVar : public Variable
{
private:
    GegenstandTyp value;

public:
    GegenstandTypVar( GegenstandTyp value );
    void setValue( GegenstandTyp value );
    GegenstandTyp getValue() const;
};

class Gegenstand : public GameObject
{
private:
    GegenstandTyp typ;
    int id;

public:
    Gegenstand( int id, GegenstandTyp typ, int x = 0, int y = 0, int w = 50, int h = 50 );
    int getId() const;
    GegenstandTyp getTyp() const;
};