#include "Schalter.h"
#include "Spiel.h"


Schalter::Schalter( int id, int x, int y, int width, int height, bool aktive )
    : GameObject( SCHALTER, x, y, width, height )
{
    this->id = id;
    this->aktiv = aktive;
    aktivierungen = 0;
}

void Schalter::setAktive( bool aktiv )
{
    this->aktiv = aktiv;
}

void Schalter::press( Spiel *zSpiel )
{
    zSpiel->setSchalterZuletztAktiviert( (Schalter *)getThis() );
    aktivierungen++;
    Ereignis *e = new Ereignis( SCHALTER_AKTIVIERT );
    e->addParameter( "Betroffener Schalter", getThis() );
    zSpiel->throwEvent( e );
}

int Schalter::getAnzahlAktivierungen() const
{
    return aktivierungen;
}

bool Schalter::isAktive() const
{
    return aktiv;
}

int Schalter::getId() const
{
    return id;
}